#pragma once

#define MBOOT2_MAGIC 0xE85250D6
#define MBOOT2_REPLY 0x36D76289
#define MBOOT2_ARCH 0
#define MBOOT2_LENGTH (Multiboot2HeaderEnd - Multiboot2Header)
#define MBOOT2_CHECKSUM -(MBOOT2_MAGIC + MBOOT2_ARCH + MBOOT2_LENGTH)

#define MBOOT2_TAG_CMDLINE 1
#define MBOOT2_TAG_BOOTLOADER 2
#define MBOOT2_TAG_MMAP 6
#define MBOOT2_TAG_FBINFO 8

#ifndef __ASSEMBLER__
#include <stddef.h>
struct kernel_boot_data_st{
    int multiboot_version;
    char *bootloader;
    char *commandline;
    size_t mmap_size;
    unsigned int mmap_len;
    void *mmap;
};

extern struct kernel_boot_data_st kernel_boot_data;

int multiboot_init(uint64_t magic, void *mboot_info);
int multiboot_get_memory_area(size_t index, uintptr_t *start, uintptr_t *end, uint32_t *type);
#endif